Bug 15459 - [meta-bug] there should be a tree combiner like the rtl one
Summary: [meta-bug] there should be a tree combiner like the rtl one
Status: RESOLVED FIXED
Alias: None
Product: gcc
Classification: Unclassified
Component: tree-optimization (show other bugs)
Version: 4.0.0
: P2 enhancement
Target Milestone: ---
Assignee: Andrew Pinski
URL:
Keywords: meta-bug, missed-optimization
Depends on: 21850 22360
Blocks: 14753 19792 31531 14287 14303 14490 14541 14752 14792 14796 14844 14847 15017 15241 15255 15256 15310 15346 15347 15348 15350 15452 15457 15458 15826 16107 17141 17165 18892 19790 21608 21690 24568 24964 27090 28685 29985
  Show dependency treegraph
 
Reported: 2004-05-15 12:22 UTC by Andrew Pinski
Modified: 2014-10-31 04:01 UTC (History)
4 users (show)

See Also:
Host:
Target:
Build:
Known to work:
Known to fail:
Last reconfirmed: 2007-07-01 01:19:34


Attachments
the new pass (2.90 KB, patch)
2004-05-18 01:05 UTC, Andrew Pinski
Details | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Andrew Pinski 2004-05-15 12:22:14 UTC
Just a list of bugs which should be fixed with the tree combiner.
Comment 1 Andrew Pinski 2004-05-15 12:22:30 UTC
Confirmed.
Comment 2 Andrew Pinski 2004-05-17 13:44:54 UTC
Mine, I will attach a patch here soon.
Comment 3 Andrew Pinski 2004-05-18 01:05:11 UTC
Created attachment 6325 [details]
the new pass

Right now this pass is very basic but can be improved.	If someone would take a
look at it I would be very happy.  There still needs to be some comments added
but it works and it solves some of the dependent bugs.
Comment 4 Andrew Pinski 2004-06-21 05:09:11 UTC
Will submit a new version which is much better of this version soon.
Comment 5 Andrew Pinski 2005-05-31 22:36:50 UTC
Patch posted here: <http://gcc.gnu.org/ml/gcc-patches/2005-05/msg02951.html> but it has a 
couple of regressions.  First PR 21850.  Second a latent bug in VRP saying the CFG will always be 
cleaned which is not true.
Comment 6 Steven Bosscher 2005-09-29 15:38:26 UTC
A number of xfailed tests in the tree-ssa test suite (e.g. bool-3.c) should 
start working if you add a tree combiner. 
 
Comment 7 Andrew Pinski 2006-01-17 16:48:22 UTC
I don't have time for this bug.
Comment 8 Andrew Pinski 2012-02-12 04:28:50 UTC
tree-ssa-forwprop is becoming one but slowly.  In the next few months, I am going to take what is done in fold-const and port them to forwprop.  I already posted one of them: http://gcc.gnu.org/ml/gcc-patches/2012-01/msg00945.html .

I will try to work on the rest and more.
Comment 9 Andrew Pinski 2014-10-31 04:01:24 UTC
This is fixed in a much better way by the following patch:
https://gcc.gnu.org/git/?p=gcc.git;a=commit;h=2165588a33dc7d63840774b2aac61be999ef17ae